//	*****************************************************************************
//
//	Copyright (c) 1998 by David Cole -- All rights reserved.
//
//	Filename:	MFCUTILS.H
//
//	Author:		David P. Cole
//
//	Comments:
//
//				This source file may be used in any software for any purpose
//				as long as this notice and the copyright information remain
//				intact.
//
//				Send comments to:
//					David Cole
//					P.O. Box 2813
//					Seattle, WA 98111-2813
//					DLRdave@aol.com
//					http://members.aol.com/DLRdave
//
//	This header block generated by Commentizer v1.0
//
//	*****************************************************************************
//
//	Purpose:
//
//		Utility functions to help with window visibility,
//		document finding and deferred updating.
//
//	History:
//
//		Initial Version - Released with TIA 1.0.0001, November, 1998.
//
//	*****************************************************************************

#ifndef DLR_MFCUTILS_H
#define DLR_MFCUTILS_H

#ifndef __cplusplus
#error This file requires C++ compilation...
#endif

//	Constants:
#define MU_CMP_PATHNAME	(0L)
#define MU_CMP_TITLE	(1L)

//	Prototypes:
BOOL MU_GetMainWndVisible(void);
void MU_SetMainWndVisible(const BOOL bNewValue= TRUE);

int MU_GetCDocumentCount(void);
CDocument *MU_GetCDocument(const int nIndex);
LPUNKNOWN MU_GetCDocumentInterface(const int nIndex, const IID &iid);
LPDISPATCH MU_GetCDocumentDispatch(const int nIndex);

CDocument *MU_FindCDocument(LPCTSTR szName, const long nCompare= MU_CMP_PATHNAME);
LPUNKNOWN MU_FindCDocumentInterface(LPCTSTR szName, const IID &iid);
LPDISPATCH MU_FindCDocumentDispatch(LPCTSTR szName);

CDocument *MU_GetCDocumentFromVariant(const VARIANT &vDocID);
LPUNKNOWN MU_GetCDocumentInterfaceFromVariant(const VARIANT &vDocID, const IID &iid);
LPDISPATCH MU_GetCDocumentDispatchFromVariant(const VARIANT &vDocID);

BOOL MU_GetDeferringUpdates(void);
void MU_SetDeferringUpdates(BOOL bNewValue= TRUE);
BOOL MU_StopDeferringUpdatesAfter(DWORD dwTime= 1500);

#endif	//	DLR_MFCUTILS_H
