//	*****************************************************************************
//
//	Copyright (c) 1998 by David Cole -- All rights reserved.
//
//	Filename:	TAPPAUT.CPP
//
//	Author:		David P. Cole
//
//	Comments:
//
//				This source file may be used in any software for any purpose
//				as long as this notice and the copyright information remain
//				intact.
//
//				Send comments to:
//					David Cole
//					P.O. Box 2813
//					Seattle, WA 98111-2813
//					DLRdave@aol.com
//					http://members.aol.com/DLRdave
//
//	This header block generated by Commentizer v1.0
//
//	*****************************************************************************
//
//	Purpose:
//
//		Implementation of the TIA.Application Automation object.
//
//	History:
//
//		Initial Version - Released with TIA 1.0.0001, November, 1998.
//
//	*****************************************************************************

// TAppAut.cpp : implementation file
//

#include "stdafx.h"
#include "tia.h"
#include "TAppAut.h"
#include "MFCUtils.h"
#include "TIADoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTIAAppAut

IMPLEMENT_DYNCREATE(CTIAAppAut, CCmdTarget)

CTIAAppAut::CTIAAppAut()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	
	AfxOleLockApp();
}

CTIAAppAut::~CTIAAppAut()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	
	AfxOleUnlockApp();
}


void CTIAAppAut::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CTIAAppAut, CCmdTarget)
	//{{AFX_MSG_MAP(CTIAAppAut)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CTIAAppAut, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CTIAAppAut)
	DISP_PROPERTY_EX(CTIAAppAut, "Visible", GetVisible, SetVisible, VT_I4)
	DISP_PROPERTY_EX(CTIAAppAut, "Name", GetName, SetNotSupported, VT_BSTR)
	DISP_PROPERTY_EX(CTIAAppAut, "FullPathName", GetFullPathName, SetNotSupported, VT_BSTR)
	DISP_PROPERTY_EX(CTIAAppAut, "Version", GetVersion, SetNotSupported, VT_I4)
	DISP_PROPERTY_EX(CTIAAppAut, "CommandLine", GetCommandLine, SetNotSupported, VT_BSTR)
	DISP_FUNCTION(CTIAAppAut, "AddDocument", AddDocument, VT_DISPATCH, VTS_BSTR)
	DISP_FUNCTION(CTIAAppAut, "GetDocument", GetDocument, VT_DISPATCH, VTS_VARIANT)
	DISP_FUNCTION(CTIAAppAut, "GetDocumentCount", GetDocumentCount, VT_I4, VTS_NONE)
	DISP_FUNCTION(CTIAAppAut, "RemoveDocument", RemoveDocument, VT_EMPTY, VTS_VARIANT)
	DISP_DEFVALUE(CTIAAppAut, "Name")
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// *****************************************************************************
//	ClassWizard Leftovers:

// Note: we add support for IID_ITIAAppAut to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {8857D280-6223-11D2-9B8C-44455354616F}
//static const IID IID_ITIAAppAut =
//{ 0x8857d280, 0x6223, 0x11d2, { 0x9b, 0x8c, 0x44, 0x45, 0x53, 0x54, 0x61, 0x6f } };
// *****************************************************************************
//	CHANGED_GUID

//	Since we include the generated header file, TiaTLB.h,
//	use the ID's defined in there:

BEGIN_INTERFACE_MAP(CTIAAppAut, CCmdTarget)
	INTERFACE_PART(CTIAAppAut, DIID_ITIAApplicationDisp, Dispatch)		//	CHANGED_GUID
	INTERFACE_PART(CTIAAppAut, IID_ITIAApplication, Dual_TIA_App)		//  DUAL_INTERFACE_SUPPORT
	DUAL_ERRORINFO_PART(CTIAAppAut)										//  DUAL_INTERFACE_SUPPORT
END_INTERFACE_MAP()

// {8857D281-6223-11D2-9B8C-44455354616F}
//	E7DC8241-6A03-11D2-9B8C-44455354616F
IMPLEMENT_OLECREATE(CTIAAppAut, "TIA.Application", 0xE7DC8241, 0x6A03, 0x11d2, 0x9b, 0x8c, 0x44, 0x45, 0x53, 0x54, 0x61, 0x6f)
		//	CHANGED_GUID

/////////////////////////////////////////////////////////////////////////////
// CTIAAppAut message handlers

long CTIAAppAut::GetVisible() 
{
	return (long) MU_GetMainWndVisible();
}

void CTIAAppAut::SetVisible(long nNewValue) 
{
	MU_SetMainWndVisible((BOOL) nNewValue);
	AfxOleSetUserCtrl((BOOL) nNewValue);
}

#define SZ_APP_NAME		_T("TIA - Version 1.0.0001")
#define TIA_VERSION		(0x01000001L)
	//	of the form 0xMMmmbbbb
	//	MM = major version number ; mm = minor version number ; bbbb = build number

BSTR CTIAAppAut::GetName() 
{
	CString strResult(SZ_APP_NAME);
	return strResult.AllocSysString();
}

BSTR CTIAAppAut::GetFullPathName() 
{
	CString strResult;
	GetModuleFileName(AfxGetInstanceHandle(), strResult.GetBuffer(MAX_PATH), MAX_PATH);
	strResult.ReleaseBuffer();
	return strResult.AllocSysString();
}

long CTIAAppAut::GetVersion() 
{
	return TIA_VERSION;
}

LPDISPATCH CTIAAppAut::AddDocument(LPCTSTR szFullPathName) 
{
	HRESULT hr= E_FAIL;
	BOOL bUserCtrl= AfxOleGetUserCtrl();	//	Restore later, see comments below...
	LPDISPATCH pDisp= NULL;


	//	First try to find it in our open documents:
	pDisp= (LPDISPATCH) MU_FindCDocumentInterface(szFullPathName, DIID_ITIADocumentDisp);
	if (NULL!=pDisp)
	{
		//	Already open, return reference to existing document:
		return pDisp;
	}

	//	Create a new blank document:
	hr= CoCreateInstance(CLSID_Document, NULL, CLSCTX_ALL, DIID_ITIADocumentDisp, (void **) &pDisp);

	//	Attempt to open the named file for this document:
	//		(If name is NULL or "", then this method
	//		returns a new blank document.)
	if (NULL!=szFullPathName && TCHAR(0)!=szFullPathName[0])
	{
		CString cstrName;
		BSTR bstrName;
		IPersistFile *pPF= NULL;

		if (SUCCEEDED(hr))
		{
			hr= pDisp->QueryInterface(IID_IPersistFile, (void **) &pPF);
		}

		if (SUCCEEDED(hr))
		{
			cstrName= szFullPathName;
			bstrName= cstrName.AllocSysString();

			hr= pPF->Load(bstrName, STGM_READ);

			//	Make sure it reads as a failure code
			//	if it's not NOERROR:
			if (NOERROR!=hr && SUCCEEDED(hr))
			{
				hr= E_FAIL;
			}

			SysFreeString(bstrName);
			bstrName= NULL;

			pPF->Release();
			pPF= NULL;
		}
	}


	//	If UserCtrl was FALSE before the doc create, keep it FALSE.
	//		(Likewise for TRUE, of course... - CoCreateInstance
	//		 calls through OnNewDocument which sets it to TRUE;
	//		 if we leave it like that, then the app doesn't
	//		 go away when all the objects are released...)

	//	Additionally, any docs opened via this automation
	//	method MUST be *closed* via automation before they
	//	are released. Callers of this method (oDoc = oApp.AddDocument)
	//	MUST call (oApp.RemoveDocument oDoc) before they call
	//	(Set oDoc = Nothing) or before doc goes out of scope...
	//	Alternatively, the app could be made visible (oApp.Visible =
	//	True) and left for the user to deal with.

	AfxOleSetUserCtrl(bUserCtrl);


	//	If any of the CoCreateInstance, QueryInterface or
	//	Load calls above FAILED, then bail:

	if (FAILED(hr))
	{
		//	Release the object if we created it:
		if (NULL!=pDisp)
		{
			pDisp->Release();
			pDisp= NULL;
		}

		AfxThrowOleException(hr);
	}

	//	If pDisp is NULL even though hr SUCCEEDED,
	//	then bail with a generic failure:

	if (NULL==pDisp)
	{
		AfxThrowOleException(E_FAIL);
	}

	//	Should be a valid, AddRef-ed pDisp.
	//	Caller must Release when done:

	return pDisp;
}

BSTR CTIAAppAut::GetCommandLine() 
{
	CString strResult(AfxGetApp()->m_lpCmdLine);
	return strResult.AllocSysString();
}

LPDISPATCH CTIAAppAut::GetDocument(const VARIANT FAR& vDocID) 
{
	return MU_GetCDocumentDispatchFromVariant(vDocID);
}

long CTIAAppAut::GetDocumentCount() 
{
	return MU_GetCDocumentCount();
}

void CTIAAppAut::RemoveDocument(const VARIANT FAR& vDocID) 
{
	CTIADoc *pDoc= (CTIADoc *) MU_GetCDocumentFromVariant(vDocID);
	if (NULL!=pDoc && pDoc->IsKindOf(RUNTIME_CLASS(CTIADoc)))
	{
		pDoc->ForceClose();
	}
}


// *****************************************************************************
//  DUAL_INTERFACE_SUPPORT

//	In addition to this bottom section of the file, there are also two extra
//	entries in the interface map up above. One for the dual interface and one
//	for ISupportErrorInfo.

//	Delegate standard IDispatch methods to MFC IDispatch implementation:
DELEGATE_DUAL_INTERFACE(CTIAAppAut, Dual_TIA_App)

//	Implement ISupportErrorInfo for this dual interface:
IMPLEMENT_DUAL_ERRORINFO(CTIAAppAut, IID_ITIAApplication)


STDMETHODIMP CTIAAppAut::XDual_TIA_App::get_Name(BSTR FAR* pbstrName)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		(*pbstrName)= pThis->GetName();
		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::get_Visible(long FAR* pnVisible)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		(*pnVisible)= pThis->GetVisible();
		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::put_Visible(long nVisible)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		pThis->SetVisible(nVisible);
		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::get_FullPathName(BSTR FAR* pbstrFullPathName)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		(*pbstrFullPathName)= pThis->GetFullPathName();
		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::get_Version(long FAR* pnVersion)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		(*pnVersion)= pThis->GetVersion();
		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::get_CommandLine(BSTR FAR* pbstrCommandLine)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		(*pbstrCommandLine)= pThis->GetCommandLine();
		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::AddDocument(BSTR bstrFullPathName, ITIADocument FAR* FAR* ppDoc)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		CString cstr(bstrFullPathName);
		HRESULT hr= E_FAIL;
		LPDISPATCH pDisp= pThis->AddDocument(cstr);

		if (NULL!=pDisp)
		{
			hr= pDisp->QueryInterface(IID_ITIADocument, (void **) ppDoc);

			pDisp->Release();
			pDisp= NULL;
		}

		if (FAILED(hr))
		{
			AfxThrowOleException(hr);
		}

		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::GetDocument(VARIANT vDocID, ITIADocument FAR* FAR* ppDoc)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		HRESULT hr= E_FAIL;
		LPDISPATCH pDisp= pThis->GetDocument(vDocID);

		if (NULL!=pDisp)
		{
			hr= pDisp->QueryInterface(IID_ITIADocument, (void **) ppDoc);

			pDisp->Release();
			pDisp= NULL;
		}

		if (FAILED(hr))
		{
			AfxThrowOleException(hr);
		}

		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::GetDocumentCount(long FAR* pnCount)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		(*pnCount)= pThis->GetDocumentCount();
		return NOERROR;
	}
	CATCH_ALL_DUAL
}

STDMETHODIMP CTIAAppAut::XDual_TIA_App::RemoveDocument(VARIANT vDocID)
{
	METHOD_PROLOGUE(CTIAAppAut, Dual_TIA_App)
	TRY_DUAL(IID_ITIAApplication)
	{
		pThis->RemoveDocument(vDocID);
		return NOERROR;
	}
	CATCH_ALL_DUAL
}
