//	*****************************************************************************
//
//	Copyright (c) 1998 by David Cole -- All rights reserved.
//
//	Filename:	TAPPAUT.H
//
//	Author:		David P. Cole
//
//	Comments:
//
//				This source file may be used in any software for any purpose
//				as long as this notice and the copyright information remain
//				intact.
//
//				Send comments to:
//					David Cole
//					P.O. Box 2813
//					Seattle, WA 98111-2813
//					DLRdave@aol.com
//					http://members.aol.com/DLRdave
//
//	This header block generated by Commentizer v1.0
//
//	*****************************************************************************
//
//	Purpose:
//
//		Declaration of the TIA.Application Automation object.
//
//	History:
//
//		Initial Version - Released with TIA 1.0.0001, November, 1998.
//
//	*****************************************************************************

// TAppAut.h : header file
//

#ifndef DLR_TAPPAUT_H
#define DLR_TAPPAUT_H

#include "MFCDual.h"	//	DUAL_INTERFACE_SUPPORT
#include "TiaTLB.h"		//	ITIA* interfaces

/////////////////////////////////////////////////////////////////////////////
// CTIAAppAut command target

class CTIAAppAut : public CCmdTarget
{
	DECLARE_DYNCREATE(CTIAAppAut)

	CTIAAppAut();           // protected constructor used by dynamic creation

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTIAAppAut)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CTIAAppAut();

	// Generated message map functions
	//{{AFX_MSG(CTIAAppAut)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_OLECREATE(CTIAAppAut)

	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CTIAAppAut)
	afx_msg long GetVisible();
	afx_msg void SetVisible(long nNewValue);
	afx_msg BSTR GetName();
	afx_msg BSTR GetFullPathName();
	afx_msg long GetVersion();
	afx_msg BSTR GetCommandLine();
	afx_msg LPDISPATCH AddDocument(LPCTSTR szFullPathName);
	afx_msg LPDISPATCH GetDocument(const VARIANT FAR& vDocID);
	afx_msg long GetDocumentCount();
	afx_msg void RemoveDocument(const VARIANT FAR& vDocID);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

// *****************************************************************************
//  DUAL_INTERFACE_SUPPORT
	BEGIN_DUAL_INTERFACE_PART(Dual_TIA_App, ITIAApplication)
		//	Copy and paste ITIAApplication methods here from TiaTLB.h
		//	after it has been generated for the first time...
		//	Don't forget to remove the "PURE" or "=0" designation.
		//	We do need to make this a concrete class...

	    STDMETHOD(get_Name)(THIS_ BSTR FAR* pbstrName);
	    STDMETHOD(get_Visible)(THIS_ long FAR* pnVisible);
	    STDMETHOD(put_Visible)(THIS_ long nVisible);
	    STDMETHOD(get_FullPathName)(THIS_ BSTR FAR* pbstrFullPathName);
	    STDMETHOD(get_Version)(THIS_ long FAR* pnVersion);
	    STDMETHOD(get_CommandLine)(THIS_ BSTR FAR* pbstrCommandLine);
	    STDMETHOD(AddDocument)(THIS_ BSTR bstrFullPathName, ITIADocument FAR* FAR* ppDoc);
	    STDMETHOD(GetDocument)(THIS_ VARIANT vDocID, ITIADocument FAR* FAR* ppDoc);
	    STDMETHOD(GetDocumentCount)(THIS_ long FAR* pnCount);
	    STDMETHOD(RemoveDocument)(THIS_ VARIANT vDocID);

	END_DUAL_INTERFACE_PART(Dual_TIA_App)
    DECLARE_DUAL_ERRORINFO()
};

#endif	//	DLR_TAPPAUT_H

/////////////////////////////////////////////////////////////////////////////
