//	*****************************************************************************
//
//	Copyright (c) 1998 by David Cole -- All rights reserved.
//
//	Filename:	TIA.CPP
//
//	Author:		David P. Cole
//
//	Comments:
//
//				This source file may be used in any software for any purpose
//				as long as this notice and the copyright information remain
//				intact.
//
//				Send comments to:
//					David Cole
//					P.O. Box 2813
//					Seattle, WA 98111-2813
//					DLRdave@aol.com
//					http://members.aol.com/DLRdave
//
//	This header block generated by Commentizer v1.0
//
//	*****************************************************************************
//
//	Purpose:
//
//		Implementation of the CTIAApp object.
//			Important points about the code in this file:
//			- m_dwStopDeferringDelay initialization
//			- TypeLib registration
//			- OnIdle code to end Deferred updates
//
//	History:
//
//		Initial Version - Released with TIA 1.0.0001, November, 1998.
//
//	*****************************************************************************

// TIA.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TIA.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "IpFrame.h"
#include "TIADoc.h"
#include "TIAView.h"
#include "MFCUtils.h"
#include <afxctl.h>			//	for AfxOleRegisterTypeLib
#include "TiaTLB.h"			//	for LIBID_TIA

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTIAApp

BEGIN_MESSAGE_MAP(CTIAApp, CWinApp)
	//{{AFX_MSG_MAP(CTIAApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTIAApp construction

CTIAApp::CTIAApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_dwStopDeferringDelay= 500;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTIAApp object

CTIAApp theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.

// {091779A0-5E25-11D2-9B8C-44455354616F}
//static const CLSID clsid =
//{ 0x91779a0, 0x5e25, 0x11d2, { 0x9b, 0x8c, 0x44, 0x45, 0x53, 0x54, 0x61, 0x6f } };
//	use CLSID_Document instead - defined in TiaTLB.h
//	CHANGED_GUID

/////////////////////////////////////////////////////////////////////////////
// CTIAApp initialization

BOOL CTIAApp::InitInstance()
{
	TRACE(_T("* CTIAApp::InitInstance\015\012"));
	TRACE(_T("*\015\012"));

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_TIATYPE,
		RUNTIME_CLASS(CTIADoc),
		RUNTIME_CLASS(CTIAChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CTIAView));
	pDocTemplate->SetServerInfo(
		IDR_TIATYPE_SRVR_EMB, IDR_TIATYPE_SRVR_IP,
		RUNTIME_CLASS(CTIAInPlaceFrame));
	AddDocTemplate(pDocTemplate);

	// Connect the COleTemplateServer to the document template.
	//  The COleTemplateServer creates new documents on behalf
	//  of requesting OLE containers by using information
	//  specified in the document template.
	m_server.ConnectTemplate(CLSID_Document, pDocTemplate, FALSE);
	//	CHANGED_GUID

	// Register all OLE server factories as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleTemplateServer::RegisterAll();
		// Note: MDI applications register all server objects without regard
		//  to the /Embedding or /Automation on the command line.

	// create main MDI Frame window
	CTIAMainFrame* pMainFrame = new CTIAMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Check to see if launched as OLE server
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// Application was run with /Embedding or /Automation.  Don't show the
		//  main window in this case.
		return TRUE;
	}

	// When a server application is launched stand-alone, it is a good idea
	//  to update the system registry in case it has been damaged.
	m_server.UpdateRegistry(OAT_INPLACE_SERVER);
	COleObjectFactory::UpdateRegistryAll();

	//	Register our type lib (built into the exe as a resource)
	//	for ease of hookup from development environments that support
	//	type libs:
	AfxOleRegisterTypeLib(AfxGetInstanceHandle(), LIBID_TIA);

	//	Register the "*.tia" file extension as ours:
	RegisterShellFileTypes();

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
//	pMainFrame->ShowWindow(m_nCmdShow);
//	pMainFrame->UpdateWindow();
	//	Replace the two app wizard generated calls for showing the
	//	window with the handy-dandy utility function we have for
	//	just that purpose:
	MU_SetMainWndVisible();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CTIAAboutDlg dialog used for App About

class CTIAAboutDlg : public CDialog
{
public:
	CTIAAboutDlg();

// Dialog Data
	//{{AFX_DATA(CTIAAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTIAAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CTIAAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CTIAAboutDlg::CTIAAboutDlg() : CDialog(CTIAAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CTIAAboutDlg)
	//}}AFX_DATA_INIT
}

void CTIAAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTIAAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTIAAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CTIAAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTIAApp::OnAppAbout()
{
	CTIAAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CTIAApp commands

BOOL CTIAApp::OnIdle(LONG lCount) 
{
	BOOL bContinueIdling= FALSE;
	BOOL bStopped= FALSE;

	bContinueIdling= CWinApp::OnIdle(lCount);

	//	Turn updates back on after all MFC idle
	//	tasks are done:
	if (!bContinueIdling && MU_GetDeferringUpdates())
	{
		bStopped= MU_StopDeferringUpdatesAfter(m_dwStopDeferringDelay);
		bContinueIdling= !bStopped;
	}

	return bContinueIdling;
}

int CTIAApp::ExitInstance() 
{
	TRACE(_T("*\015\012"));
	TRACE(_T("* CTIAApp::ExitInstance\015\012"));

	return CWinApp::ExitInstance();
}
