//	*****************************************************************************
//
//	Copyright (c) 1998 by David Cole -- All rights reserved.
//
//	Filename:	TIAITEMS.H
//
//	Author:		David P. Cole
//
//	Comments:
//
//				This source file may be used in any software for any purpose
//				as long as this notice and the copyright information remain
//				intact.
//
//				Send comments to:
//					David Cole
//					P.O. Box 2813
//					Seattle, WA 98111-2813
//					DLRdave@aol.com
//					http://members.aol.com/DLRdave
//
//	This header block generated by Commentizer v1.0
//
//	*****************************************************************************
//
//	Purpose:
//
//		Declaration of TIA_DocItem and TIA_ColoredRectangle.
//
//	History:
//
//		Initial Version - Released with TIA 1.0.0001, November, 1998.
//
//	*****************************************************************************

#ifndef DLR_TIA_DOCITEMS_H
#define DLR_TIA_DOCITEMS_H

//	***************************************************************************
//	TIA_DocItem

class CTIADoc;

class TIA_DocItem : public CObject
{
	DECLARE_SERIAL(TIA_DocItem)

public:
	TIA_DocItem();
	virtual ~TIA_DocItem();

public:
	HRESULT SetDoc(CTIADoc *pDoc);
	CTIADoc *GetDoc(void);

private:
	CTIADoc *m_pDoc;
};


//	***************************************************************************
//	TIA_ColoredRectangle

class CTIARectAut;

class TIA_ColoredRectangle : public TIA_DocItem
{
	DECLARE_SERIAL(TIA_ColoredRectangle)

public:
	TIA_ColoredRectangle();
	virtual ~TIA_ColoredRectangle();

	HRESULT SetRect(const CRect &r);
	HRESULT GetRect(CRect &r) const;
	HRESULT SetColor(const COLORREF &rgb);
	HRESULT GetColor(COLORREF &rgb) const;
	virtual void Serialize(CArchive &ar);

	LPDISPATCH GetAutomationObject(void);
	void ForgetAutomationObject(void);

private:
	CRect m_rect;
	COLORREF m_rgb;
	CTIARectAut *m_pAut;
};


#endif	//	DLR_TIA_DOCITEMS_H
