VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} TIAForm 
   Caption         =   "TIA Form Interface"
   ClientHeight    =   5820
   ClientLeft      =   45
   ClientTop       =   975
   ClientWidth     =   5535
   OleObjectBlob   =   "TIAForm.frx":0000
   StartUpPosition =   0  'Manual
End
Attribute VB_Name = "TIAForm"
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'//  *****************************************************************************
'//
'//  Copyright (c) 1998 by David Cole -- All rights reserved.
'//
'//  Filename:   TIAFORM.FRM / TIAFORM.FRX
'//
'//  Author:     David P. Cole
'//
'//  Comments:
'//
'//              This source file may be used in any software for any purpose
'//              as long as this notice and the copyright information remain
'//              intact.
'//
'//              Send comments to:
'//                  David Cole
'//                  P.O. Box 2813
'//                  Seattle, WA 98111-2813
'//                  DLRdave@aol.com
'//                  http://members.aol.com/DLRdave
'//
'//  This header block generated by Commentizer v1.0
'//
'//  *****************************************************************************
'//
'//  Purpose:
'//
'//      Implement event handlers for all the controls
'//      on TIAForm. ALL errors are trapped and ignored.
'//      Sometimes you can tell that some error has occurred
'//      by observing that there is no new output in the
'//      text control txtResult.
'//
'//  History:
'//
'//      Initial Version - Released with TIA 1.0.0001, November, 1998.
'//
'//  *****************************************************************************

Option Explicit

Dim m_oFrmApp As TIA.Application
Dim m_oFrmDoc As TIA.Document
Dim m_oFrmItem As TIA.Rectangle

Public Sub UpdateEnabledStates()
    Dim bAppEnabled As Boolean
    Dim bDocEnabled As Boolean
    Dim bItemEnabled As Boolean
    Dim oCtl As Object

    bAppEnabled = Not (m_oFrmApp Is Nothing)
    bDocEnabled = Not (m_oFrmDoc Is Nothing)
    bItemEnabled = Not (m_oFrmItem Is Nothing)

    For Each oCtl In frmApp.Controls
        oCtl.Enabled = bAppEnabled
    Next

    For Each oCtl In frmDoc.Controls
        oCtl.Enabled = bDocEnabled
    Next

    For Each oCtl In frmItem.Controls
        oCtl.Enabled = bItemEnabled
    Next
End Sub

Public Sub ClearResult()
    txtResult.Text = ""
End Sub

Public Sub ReportResult(ByRef sz As String)
    txtResult.Text = sz
    UpdateEnabledStates
End Sub

Private Sub CommandButton1_Click()
    On Error Resume Next
    ClearResult
    Set m_oFrmApp = CreateObject("TIA.Application")
    ReportResult "Create m_oFrmApp returned: " & m_oFrmApp
End Sub

Private Sub CommandButton10_Click()
    On Error Resume Next
    ClearResult
    Set m_oFrmDoc = m_oFrmApp.GetDocument(txtAppInput.Text)
    ReportResult "m_oFrmApp.GetDocument(""" & txtAppInput.Text & """) returned: " & m_oFrmDoc
End Sub

Private Sub CommandButton11_Click()
    On Error Resume Next
    ClearResult
    Set m_oFrmDoc = m_oFrmApp.AddDocument(txtAppInput.Text)
    ReportResult "m_oFrmApp.AddDocument(""" & txtAppInput.Text & """) returned: " & m_oFrmDoc
End Sub

Private Sub CommandButton12_Click()
    On Error Resume Next
    ClearResult
    m_oFrmApp.RemoveDocument txtAppInput.Text
    ReportResult "m_oFrmApp.RemoveDocument """ & txtAppInput.Text & """ called..."
End Sub

Private Sub CommandButton13_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmApp.GetDocumentCount returned: " & m_oFrmApp.GetDocumentCount
End Sub

Private Sub CommandButton14_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmApp.CommandLine returned: " & m_oFrmApp.CommandLine
End Sub

Private Sub CommandButton15_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmApp.FullPathName returned: " & m_oFrmApp.FullPathName
End Sub

Private Sub CommandButton16_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmApp.Name returned: " & m_oFrmApp.Name
End Sub

Private Sub CommandButton17_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmApp.Version returned: " & m_oFrmApp.Version
End Sub

Private Sub CommandButton18_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmApp.Visible returned: " & m_oFrmApp.Visible
End Sub

Private Sub CommandButton19_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmDoc.Name returned: " & m_oFrmDoc.Name
End Sub

Private Sub CommandButton2_Click()
    On Error Resume Next
    ClearResult
    Set m_oFrmApp = Nothing
    ReportResult "m_oFrmApp Released"
End Sub

Private Sub CommandButton20_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmDoc.FullPathName returned: " & m_oFrmDoc.FullPathName
End Sub

Private Sub CommandButton21_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmDoc.Modified returned: " & m_oFrmDoc.Modified
End Sub

Private Sub CommandButton22_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmDoc.Visible returned: " & m_oFrmDoc.Visible
End Sub

Private Sub CommandButton23_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmDoc.Save returned: " & m_oFrmDoc.Save
End Sub

Private Sub CommandButton24_Click()
    Dim n As Long
    On Error Resume Next
    ClearResult
    n = m_oFrmDoc.SaveAs(txtDocInput.Text)
    ReportResult "m_oFrmDoc.SaveAs(""" & txtDocInput.Text & """) returned: " & n
End Sub

Private Sub CommandButton25_Click()
    Dim nLeft As Long
    Dim nTop As Long
    Dim nWidth As Long
    Dim nHeight As Long
    Dim nR As Long
    Dim nG As Long
    Dim nB As Long
    On Error Resume Next
    ClearResult
    ParseTextForSevenNumbers txtDocInput.Text, nLeft, nTop, nWidth, nHeight, nR, nG, nB
    Set m_oFrmItem = m_oFrmDoc.AddColoredRect(nLeft, nTop, nWidth, nHeight, TIAMakeColor(nR, nG, nB))
    ReportResult "m_oFrmDoc.AddColoredRect(" & nLeft & ", " & nTop & ", " & nWidth & ", " & nHeight & ", " & TIAMakeColor(nR, nG, nB) & ") returned: " & m_oFrmItem
End Sub

Private Sub CommandButton26_Click()
    On Error Resume Next
    ClearResult
    m_oFrmDoc.Modified = True
    ReportResult "m_oFrmDoc.Modified = " & m_oFrmDoc.Modified
End Sub

Private Sub CommandButton27_Click()
    On Error Resume Next
    ClearResult
    m_oFrmDoc.Modified = False
    ReportResult "m_oFrmDoc.Modified = " & m_oFrmDoc.Modified
End Sub

Private Sub CommandButton28_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmItem.Color returned: " & m_oFrmItem.Color
End Sub

Private Sub CommandButton29_Click()
    On Error Resume Next
    ClearResult
    ReportResult "m_oFrmItem.Name returned: " & m_oFrmItem.Name
End Sub

Private Sub CommandButton3_Click()
    On Error Resume Next
    ClearResult
    m_oFrmApp.Visible = True
    ReportResult "m_oFrmApp.Visible = " & m_oFrmApp.Visible
End Sub

Private Sub CommandButton30_Click()
    Dim nLeft As Long
    Dim nTop As Long
    Dim nWidth As Long
    Dim nHeight As Long
    Dim nR As Long
    Dim nG As Long
    Dim nB As Long
    On Error Resume Next
    ClearResult
    ParseTextForSevenNumbers txtItemInput.Text, nLeft, nTop, nWidth, nHeight, nR, nG, nB
    m_oFrmItem.SetRectangle nLeft, nTop, nWidth, nHeight
    ReportResult "m_oFrmItem.SetRectangle called with: " & nLeft & ", " & nTop & ", " & nWidth & ", " & nHeight
End Sub

Private Sub CommandButton31_Click()
    Dim nLeft As Long
    Dim nTop As Long
    Dim nWidth As Long
    Dim nHeight As Long
    On Error Resume Next
    ClearResult
    m_oFrmItem.GetRectangle nLeft, nTop, nWidth, nHeight
    ReportResult "m_oFrmItem.GetRectangle returned: " & nLeft & ", " & nTop & ", " & nWidth & ", " & nHeight
End Sub

Private Sub CommandButton4_Click()
    On Error Resume Next
    ClearResult
    m_oFrmApp.Visible = False
    ReportResult "m_oFrmApp.Visible = " & m_oFrmApp.Visible
End Sub

Private Sub CommandButton6_Click()
    On Error Resume Next
    ClearResult
    Set m_oFrmDoc = Nothing
    ReportResult "m_oFrmDoc Released"
End Sub

Private Sub CommandButton7_Click()
    On Error Resume Next
    ClearResult
    m_oFrmDoc.Visible = True
    ReportResult "m_oFrmDoc.Visible = " & m_oFrmDoc.Visible
End Sub

Private Sub CommandButton8_Click()
    On Error Resume Next
    ClearResult
    m_oFrmDoc.Visible = False
    ReportResult "m_oFrmDoc.Visible = " & m_oFrmDoc.Visible
End Sub

Private Sub CommandButton9_Click()
    On Error Resume Next
    ClearResult
    Set m_oFrmItem = Nothing
    ReportResult "m_oFrmItem Released"
End Sub

Private Sub UserForm_Activate()
    UpdateEnabledStates
End Sub
