//	*****************************************************************************
//
//	Copyright (c) 1998 by David Cole -- All rights reserved.
//
//	Filename:	TIAVIEW.H
//
//	Author:		David P. Cole
//
//	Comments:
//
//				This source file may be used in any software for any purpose
//				as long as this notice and the copyright information remain
//				intact.
//
//				Send comments to:
//					David Cole
//					P.O. Box 2813
//					Seattle, WA 98111-2813
//					DLRdave@aol.com
//					http://members.aol.com/DLRdave
//
//	This header block generated by Commentizer v1.0
//
//	*****************************************************************************
//
//	Purpose:
//
//		Declaration of CTIAView.
//
//	History:
//
//		Initial Version - Released with TIA 1.0.0001, November, 1998.
//
//	*****************************************************************************

// TIAView.h : interface of the CTIAView class
//
/////////////////////////////////////////////////////////////////////////////

class CTIAView : public CView
{
protected: // create from serialization only
	CTIAView();
	DECLARE_DYNCREATE(CTIAView)

// Attributes
public:
	CTIADoc* GetDocument();

// Operations
public:
	HRESULT SetColor(COLORREF &rgb);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTIAView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTIAView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTIAView)
	afx_msg void OnCancelEditSrvr();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	COLORREF m_rgb;
	long m_nWidth;
	long m_nHeight;
};

#ifndef _DEBUG  // debug version in TIAView.cpp
inline CTIADoc* CTIAView::GetDocument()
   { return (CTIADoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
