//	*****************************************************************************
//
//	Copyright (c) 1998 by David Cole -- All rights reserved.
//
//	Filename:	TRECTAUT.H
//
//	Author:		David P. Cole
//
//	Comments:
//
//				This source file may be used in any software for any purpose
//				as long as this notice and the copyright information remain
//				intact.
//
//				Send comments to:
//					David Cole
//					P.O. Box 2813
//					Seattle, WA 98111-2813
//					DLRdave@aol.com
//					http://members.aol.com/DLRdave
//
//	This header block generated by Commentizer v1.0
//
//	*****************************************************************************
//
//	Purpose:
//
//		Declaration of CTIARectAut.
//
//	History:
//
//		Initial Version - Released with TIA 1.0.0001, November, 1998.
//
//	*****************************************************************************

// TRectAut.h : header file
//

#ifndef DLR_TRECTAUT_H
#define DLR_TRECTAUT_H

#include "MFCDual.h"	//	DUAL_INTERFACE_SUPPORT
#include "TiaTLB.h"		//	ITIA* interfaces

class TIA_ColoredRectangle;

/////////////////////////////////////////////////////////////////////////////
// CTIARectAut command target

class CTIARectAut : public CCmdTarget
{
	DECLARE_DYNCREATE(CTIARectAut)

	CTIARectAut();           // protected constructor used by dynamic creation

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTIARectAut)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CTIARectAut();

	// Generated message map functions
	//{{AFX_MSG(CTIARectAut)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CTIARectAut)
	afx_msg long GetColor();
	afx_msg void SetColor(long nNewValue);
	afx_msg BSTR GetName();
	afx_msg void SetRectangle(long nLeft, long nTop, long nWidth, long nHeight);
	afx_msg void GetRectangle(long FAR* pnLeft, long FAR* pnTop, long FAR* pnWidth, long FAR* pnHeight);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

// *****************************************************************************
//  DUAL_INTERFACE_SUPPORT
	BEGIN_DUAL_INTERFACE_PART(Dual_TIA_Rect, ITIARectangle)
		//	Copy and paste ITIARectangle methods here from TiaTLB.h
		//	after it has been generated for the first time...
		//	Don't forget to remove the "PURE" or "=0" designation.
		//	We do need to make this a concrete class...

	    STDMETHOD(get_Name)(THIS_ BSTR FAR* pbstrName);
	    STDMETHOD(get_Color)(THIS_ long FAR* pnColor);
	    STDMETHOD(put_Color)(THIS_ long nColor);
	    STDMETHOD(SetRectangle)(THIS_ long nLeft, long nTop, long nWidth, long nHeight);
	    STDMETHOD(GetRectangle)(THIS_ long FAR* pnLeft, long FAR* pnTop, long FAR* pnWidth, long FAR* pnHeight);

	END_DUAL_INTERFACE_PART(Dual_TIA_Rect)
    DECLARE_DUAL_ERRORINFO()

public:
	long InitRectAut(TIA_ColoredRectangle *pImp);
	void ForgetImplementationObject(TIA_ColoredRectangle *pImp);

private:
	TIA_ColoredRectangle *m_pImp;	//	pointer to the implementation object
};

/////////////////////////////////////////////////////////////////////////////

#endif	//	DLR_TRECTAUT_H
